﻿enum EScriptProfile { pCmdr, pYou, pBadGuy };

class CGameController;
class IScript;

class CScriptEngine
{
public:
	CScriptEngine(Obelisk::IObelisk *aObelisk, CGameController* aOwner);
	~CScriptEngine();

	bool Update();
	void Render();

	bool IsEnterPressed();
	bool IsEscapePressed();

	void ShowProfileCut(EScriptProfile aProfile, int aPos);
	void ShowTextCut(int aPos, int aLine, Obelisk::CString aText);
	void ShowProfileInner(EScriptProfile aProfile);
	void ShowTextInner(int aLine, Obelisk::CString aText);

	void DrawRect(float aX0, float aY0, float aX1, float aY1, const Obelisk::CColour& aColour);

	void Win();

	void GameStart();
	void FirstInRange();
	void FirstCombat();
	void FirstRank();
	void FirstIslandWon();
	void LevelWon(int aLevel);

private:
	Obelisk::IObelisk *mObelisk;
	CGameController *mOwner;
	IScript *mScript;
};