﻿#include "Obelisk.h"

#include "CScriptEngine.h"
#include "IScript.h"
#include "CScriptStartCutscene.h"

using namespace Obelisk;



CScriptStartCutscene::CScriptStartCutscene()
{
	mStage = 0;
}



bool CScriptStartCutscene::Update(bool& aResult, IObelisk* aObelisk, CScriptEngine* aEngine)
{
	aResult = mStage < 10;
	if (aObelisk->MouseButtonClicked(false) || aEngine->IsEnterPressed())
		mStage++;
	if (aEngine->IsEscapePressed())
		mStage = mStage < 10 ? 10 : 11;
	return mStage == 11;
}



void CScriptStartCutscene::Render(IObelisk* aObelisk, CScriptEngine* aEngine)
{
	switch (mStage)
	{
		case 0:
			aEngine->ShowProfileCut(pCmdr, 0);
			aEngine->ShowTextCut(0, 0, SL("Commander A. R. Sole:"));
			aEngine->ShowTextCut(0, 1, SL("LISTEN UP MAGGOT, THERE'S A NEW"));
			aEngine->ShowTextCut(0, 2, SL("ASSIGNMENT FROM HIGH COMMAND."));
			break;
		case 1:
			aEngine->ShowProfileCut(pYou, 1);
			aEngine->ShowTextCut(1, 0, SL("Captain Chad Darington:"));
			aEngine->ShowTextCut(1, 1, SL("Why are you shouting?"));
			break;
		case 2:
			aEngine->ShowProfileCut(pCmdr, 0);
			aEngine->ShowTextCut(0, 0, SL("Commander A. R. Sole:"));
			aEngine->ShowTextCut(0, 1, SL("Sorry, caps lock."));
			break;
		case 3:
			aEngine->ShowProfileCut(pCmdr, 0);
			aEngine->ShowTextCut(0, 0, SL("Anyway this group of islands is suddenly very"));
			aEngine->ShowTextCut(0, 1, SL("important."));
			break;
		case 4:
			aEngine->ShowProfileCut(pCmdr, 0);
			aEngine->ShowTextCut(0, 0, SL("And not because of a recent discovery that there"));
			aEngine->ShowTextCut(0, 1, SL("is oil beneath each of them..."));
			break;
		case 5:
			aEngine->ShowProfileCut(pCmdr, 0);
			aEngine->ShowTextCut(0, 0, SL("Your task to to get as much of that Sweet,"));
			aEngine->ShowTextCut(0, 1, SL("Delicious oil as you can get!"));
			break;
		case 6:
			aEngine->ShowProfileCut(pYou, 1);
			aEngine->ShowTextCut(1, 0, SL("Captain Chad Darington:"));
			aEngine->ShowTextCut(1, 1, SL("Sounds easy."));
			break;
		case 7:
			aEngine->ShowProfileCut(pCmdr, 0);
			aEngine->ShowTextCut(0, 0, SL("Commander A. R. Sole:"));
			aEngine->ShowTextCut(0, 1, SL("Yes but our intelligence suggests the islands are"));
			aEngine->ShowTextCut(0, 2, SL("currently occupied by hostile forces."));
			break;
		case 8:
			aEngine->ShowProfileCut(pCmdr, 0);
			aEngine->ShowTextCut(0, 0, SL("You will need to take out the turrets on each of"));
			aEngine->ShowTextCut(0, 1, SL("the islands before you can take control."));
			break;
		case 9:
			aEngine->ShowProfileCut(pCmdr, 0);
			aEngine->ShowTextCut(0, 0, SL("Now get to it soldier! I wanna be taking an oil"));
			aEngine->ShowTextCut(0, 1, SL("bath before sundown!"));
			break;
		case 10:
			aEngine->ShowProfileInner(pCmdr);
			aEngine->ShowTextInner(0, SL("First up, move to the nearest island. Click on it to"));
			aEngine->ShowTextInner(1, SL("select it, then click the Move To button."));
			break;
	}
}